#include <stdio.h>
#include "ijvm_l0.h"
#include "ijvm_l1.h"
#define objref 13
#define method_fact 20
#define method_fact_npar 1
#define method_fact_nvar 3

void declare_constant()
     {
     /* constant pool */
     u_int base=*CPP;
     ijvm_l0_memory[base+0]=1;
     ijvm_l0_memory[base+1]=2;
     ijvm_l0_memory[base+2]=6;
     ijvm_l0_memory[base+3]=4;
     
     ijvm_l0_memory[base+method_fact]=0; 
     // pointer to method_fact in method area
     }

void declare_method()
     {
     /* method_fact area */
     u_int base= *PC;
      /* */
     ijvm_l0_memory[base+0]=method_fact_npar+1;         /* n of parameters */
     ijvm_l0_memory[base+1]=method_fact_nvar;           /* n of vars */
     }

void imethod_fact()
     {
     /*
     **** RDA
     0 objref
     1 param1     b
     2 var1       i
     3 var2       a
     4 var3       fct
     */

     int b  =1; /* 1 parameter */

     /* .var */
     int i  =method_fact_npar+1;        // counter
     int a  =method_fact_npar+2;        // base of mul
     int fct=method_fact_npar+3;        // return value
     /* .end-var*/

       bipush(0);
       iload(b);

       if (ificmpeq()==1) goto end_withdefinition;

       bipush(0);        // i=0    
       istore(i);

       iload(b);         // a=b    
       istore(a);

       bipush(1);        // fct=1   
       istore(fct);

whilebody:
       iload(i);
       bipush(1);        // i++
       iadd();
       istore(i);

       iload(a);
       iload(fct);       // fct*=a
       imul();
       istore(fct);

       bipush(1);
       iload(a);         // a--;
       isub();
       istore(a);

       iload(b);
       iload(i);
       isub();             // i-b

       if (iflt()==1) goto whilebody;       // i<b

       iload(fct);

       ireturn();
       return;

end_withdefinition:
       bipush(1);
       ireturn();
     }

void getmethod(int method)
     {
     switch (method)
	    {
	    case method_fact: imethod_fact(); break;
	    default: break;
	    }
     }


int  keypressed()
     {
     char ch;
     ch = getc(stdin);
     return 1;
     }

int  main()
     {

     printf("[] ijvm test\n");
     printf("\n");

     printf("This program gets the factorial of ...\n");

     ijvm_l1_init();

     declare_constant();
     declare_method();

     /* parameters */

     bipush(objref);
     iin();          // get a number from keyboard
     /* */

     getmethod(invokevirtual(method_fact));
     printf("... that is \n");
     ishow();

     ijvm_l0_register_show();
     ijvm_l1_done();

     while(keypressed() != 1);
     return 1;
     }
