#include <stdio.h>
#define u_int unsigned int

#define ijvm_memory_type int

#define ijvm_l0_memory_constantpool_size  399
#define ijvm_l0_memory_methodarea_size    199
#define ijvm_l0_memory_stackarea_size    1023
#define ijvm_l0_memory_size 2+ijvm_l0_memory_constantpool_size+ijvm_l0_memory_methodarea_size+ijvm_l0_memory_stackarea_size


ijvm_memory_type ijvm_l0_memory[ijvm_l0_memory_size];
u_int ijvm_l0_memory_pt;

struct memory_range
       {
       u_int min;
       u_int max;
       }
ijvm_l0_memory_constantpool,
ijvm_l0_memory_methodarea,    /* simulato da goto */
ijvm_l0_memory_stackarea;



u_int ijvm_l0_register_LV;                   /* punta a link ptr*/
u_int ijvm_l0_register_SP;                   /* punta a last stack val */
u_int ijvm_l0_register_PC;                   /* punta al 1 method */
u_int ijvm_l0_register_CPP;                  /* punta alla 1 const */

u_int ijvm_l0_register_myLPP;                /* mio reg: punta 1 parametro locale*/
u_int ijvm_l0_register_myLPN;                /* mio reg: n parametri locali*/

u_int ijvm_l0_register_myLVP;                /* mio reg: punta alla 1 var locale */
u_int ijvm_l0_register_myLVN;                /* mio reg: n variabili locali*/

u_int ijvm_l0_register_myLPC;                /* mio reg: previous PC */
u_int ijvm_l0_register_myLLV;                /* mio reg: previous LV */

u_int ijvm_l0_register_myLRP;                /* mio reg: punta a return value */
u_int ijvm_l0_register_myORP;                /* mio reg: punta a obj ref */


int ijvm_l0_init();
int ijvm_l0_done();
int ijvm_l0_memory_init();
int ijvm_l0_memory_show_segments();
int ijvm_l0_memory_push(int value);
int ijvm_l0_memory_pop();
int ijvm_l0_memory_stackarea_isvalid();
int ijvm_l0_memory_stackarea_show_lastcell();
int ijvm_l0_memory_show_lastcell();
int ijvm_l0_localvar_show();
int ijvm_l0_localparameter_show();

FILE *out_l0;

int  ijvm_l0_init()
     {
     if ((out_l0 = fopen("out_l0.txt", "w+")) == NULL)
	{
	printf(">>> cannot open file out_l0.txt <<<\n");
	return -1;
	}

     fprintf(out_l0,"[] ijvm_l0_init \n");

     ijvm_l0_memory_constantpool.min=0;
     ijvm_l0_memory_constantpool.max=ijvm_l0_memory_constantpool.min+
				  ijvm_l0_memory_constantpool_size;

     ijvm_l0_memory_methodarea.min  =ijvm_l0_memory_constantpool.max+1;
     ijvm_l0_memory_methodarea.max  =ijvm_l0_memory_methodarea.min+
				  ijvm_l0_memory_methodarea_size;

     ijvm_l0_memory_stackarea.min   =ijvm_l0_memory_methodarea.max+1;
     ijvm_l0_memory_stackarea.max   =ijvm_l0_memory_stackarea.min+
				  ijvm_l0_memory_stackarea_size;
     ijvm_l0_memory_init();
     ijvm_l0_memory_show_segments();

     ijvm_l0_register_myLPN=0;
     ijvm_l0_register_LV=ijvm_l0_memory_stackarea.min;
     ijvm_l0_register_SP=ijvm_l0_memory_stackarea.min;
     ijvm_l0_register_CPP=ijvm_l0_memory_constantpool.min;
     ijvm_l0_register_PC=ijvm_l0_memory_methodarea.min;

     ijvm_l0_memory_pt=ijvm_l0_register_SP;
     return 1;
     }

int  ijvm_l0_done()
     {
     fprintf(out_l0,"  ijvm_l0_done \n");
     fclose(out_l0);
     return 1;
     }


int  ijvm_l0_memory_show_segments()
     {
     fprintf(out_l0,"  ijvm_l0_memory_show_segments \n");
     fprintf(out_l0,"        constantpool [%d..%d]\n",
	     ijvm_l0_memory_constantpool.min,
	     ijvm_l0_memory_constantpool.max);
     fprintf(out_l0,"        methodarea   [%d..%d]\n",
	     ijvm_l0_memory_methodarea.min,
	     ijvm_l0_memory_methodarea.max);
     fprintf(out_l0,"        stackarea    [%d..%d]\n",
	     ijvm_l0_memory_stackarea.min,
	     ijvm_l0_memory_stackarea.max);
     return 1;
     }

int  ijvm_l0_memory_init()
     {
     u_int i;
     fprintf(out_l0,"  ijvm_l0_memory_init\n");
     fprintf(out_l0,"        memory =  %d byte\n",ijvm_l0_memory_size+1);
     for (i=0; i++; i<ijvm_l0_memory_size)
	 {
	 ijvm_l0_memory[i]=0;
	 }
     ijvm_l0_memory_pt=0;
     return 0;
     }

int  ijvm_l0_memory_push(int value)
     {
     int i=ijvm_l0_register_SP;
     i++;
     if (i>ijvm_l0_memory_size)
       {
       fprintf(out_l0,"  ijvm_l0_memory_push >>> out of memory <<<\n");
       return -1;
       }
     fprintf(out_l0,"  ijvm_l0_memory_push(%d)\n",value);
     ijvm_l0_memory[i]=value;
     ijvm_l0_register_SP++;
     return 1;
     }

int  ijvm_l0_memory_pop()
     {
     int i=ijvm_l0_register_SP;
     i--;
     if (i<0)
	{
	fprintf(out_l0,"  ijvm_l0_memory_pop >>> out of memory <<<\n");
	return -1;
	}
     fprintf(out_l0,"  ijvm_l0_memory_pop\n");
     ijvm_l0_register_SP=i;
     return 1;
     }

int  ijvm_l0_memory_stackarea_isvalid()
     {
     u_int i=ijvm_l0_register_SP;
     u_int min=ijvm_l0_memory_stackarea.min;
     u_int max=ijvm_l0_memory_stackarea.max;
     if ((i>=min) && (i<=max))
	     return 1;
	else
	     return 0;
     }

int  ijvm_l0_memory_stackarea_show_lastcell()
     {
     int i=ijvm_l0_register_SP;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l0,"  ijvm_l0_stackarea_memory_show_lastcell\n");
     fprintf(out_l0,"        stackarea[%d]=%d\n",i,value);
     return 1;
     }

int  ijvm_l0_memory_show_lastcell()
     {
     int i=ijvm_l0_memory_pt;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l0,"  ijvm_l0_memory_show_lastcell\n");
     fprintf(out_l0,"        memory[%d]=%d\n",i,value);
     return 1;
     }

void ijvm_l0_register_show()
     {
     ijvm_memory_type returnvalue=ijvm_l0_memory[ijvm_l0_register_SP];
     fprintf(out_l0,"  ijvm_l0_register_show\n");
     fprintf(out_l0,"       TYPE     VISIBLE DESCRIPTION         NAME    VALUE\n");
     fprintf(out_l0,"      ------------------------------------------------------\n");
     fprintf(out_l0,"       pointer  global  1 const              CPP   %d\n"        ,ijvm_l0_register_CPP);
     fprintf(out_l0,"       pointer  global  1 method             PC    %d\n"        ,ijvm_l0_register_PC);
     fprintf(out_l0,"       pointer  global  link pointer          LV    %d\n"        ,ijvm_l0_register_LV);
     fprintf(out_l0,"       pointer  local   obj ref             myORP   %d\n"        ,ijvm_l0_register_myORP);
     fprintf(out_l0,"       pointer  local   1 local parameter  myLPP   myLPN   %d\n",ijvm_l0_register_myLPN);
     fprintf(out_l0,"       register local   parameters          myLPN   %d\n"        ,ijvm_l0_register_myLPN);
     fprintf(out_l0,"       pointer  global  1 local var        myLVP   %d\n"        ,ijvm_l0_register_myLVP);
     fprintf(out_l0,"       register local   local vars          myLVN   %d\n"        ,ijvm_l0_register_myLVN);
     fprintf(out_l0,"       pointer  local   old PC saved        myLPC   %d\n"        ,ijvm_l0_register_myLPC);
     fprintf(out_l0,"       pointer  local   old LV saved        myLLV   %d\n"        ,ijvm_l0_register_myLLV);
     fprintf(out_l0,"       pointer  local   return-value        myLRP   %d^ = %d \n" ,ijvm_l0_register_myLRP,returnvalue);
     fprintf(out_l0,"       pointer  global  last cell stack       SP    %d\n"        ,ijvm_l0_register_SP);
     }

int  ijvm_l0_localparameter_show()
     {
     u_int i;
     u_int j=ijvm_l0_register_myLPP;
     u_int n=ijvm_l0_register_myLPN;
     fprintf(out_l0,"  ijvm_l0_localparameter_show\n");
     for (i=0; i<n; i++)
	 {
	 fprintf(out_l0,"       %dlocalparameter  memory[%d]=%d\n",
		 (i+1),(i+j),ijvm_l0_memory[i+j]);
	 }
     return 1;
     }
int  ijvm_l0_localvar_show()
     {
     u_int i;
     u_int j=ijvm_l0_register_myLVP;
     u_int n=ijvm_l0_register_myLVN;
     fprintf(out_l0,"  ijvm_l0_localvar_show\n");
     for (i=0; i<n; i++)
	 {
	 fprintf(out_l0,"       %dlocalvar  memory[%d]=%d\n",
		 (i+1),(i+j),ijvm_l0_memory[i+j]);
	 }
     return 1;
     }
