int  ijvm_l1_init();
int  ijvm_l1_done();

void iin();
void iout();
void cin();
void cout();
void bipush(ijvm_memory_type value);
void dup();
void iadd();
void imul();
void imod();
void idiv();
void isub();
void iand();
void ior();
void iload(u_int varnum);
void iloadL(u_int varnum);
void iloadP(u_int parameternum);
void istore(u_int varnum);
void ldcw(u_int index);
void swap();
void pop();
void nop();
int  ifeq();
int  iflt();
int  ificmpeq();
void ishow();
int  invokevirtual(u_int constantpooloffset);
void ireturn();

FILE *out_l1;

     u_int *CPP  =&ijvm_l0_register_CPP;
     u_int *PC   =&ijvm_l0_register_PC;
     u_int *LV   =&ijvm_l0_register_LV;
     u_int *SP   =&ijvm_l0_register_SP;
     u_int *myLPP=&ijvm_l0_register_myLPP;
     u_int *myORP=&ijvm_l0_register_myORP;
     u_int *myLVP=&ijvm_l0_register_myLVP;
     u_int *myLVN=&ijvm_l0_register_myLVN;
     u_int *myLRP=&ijvm_l0_register_myLRP;
     u_int *myLPN=&ijvm_l0_register_myLPN;
     u_int *myLPC=&ijvm_l0_register_myLPC;
     u_int *myLLV=&ijvm_l0_register_myLLV;


int  ijvm_l1_init()
     {
     if ((out_l1 = fopen("out_l1.txt", "w+")) == NULL)
	{
	printf(">>> cannot open file out_l1.txt <<<\n");
	return -1;
	}
     fprintf(out_l1,"[] ijvm_l1_init \n");
     ijvm_l0_init();
     return 1;
     }

int  ijvm_l1_done()
     {
     fprintf(out_l1,"  ijvm_l1_done \n");
     fclose(out_l1);
     ijvm_l0_done();
     return 1;
     }

void bipush(ijvm_memory_type value)
     {
     int i= *SP;
     fprintf(out_l1,"  ijvm_l1_bipush(%d)\n",value);
     fprintf(out_l1,"        stackarea[%d]=%d\n",i,value);
     ijvm_l0_memory_push(value);
     }

void dup()
     {
     int value=ijvm_l0_memory[*SP];
     fprintf(out_l1,"  ijvm_l1_dup\n");
     ijvm_l0_memory_push(value);
     }

void iadd()
     {
     int i=*SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_iadd\n");
     fprintf(out_l1,"        %d iadd %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a+b));
     }

void isub()
     {
     int i=*SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_isub\n");
     fprintf(out_l1,"        %d isub %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a-b));
     }

void imul()
     {
     int i=*SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_imul\n");
     fprintf(out_l1,"        %d imul %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a * b));
     }

void imod()
     {
     int i=*SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_imod\n");
     fprintf(out_l1,"        %d imod %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a % b));
     }

void idiv()
     {
     int i=*SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_idiv\n");
     fprintf(out_l1,"        %d idiv %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     if (b == 0)
	{
	fprintf(out_l1,"        error: division vy zero");
	}
	else
	{
	ijvm_l0_memory_pop();
	ijvm_l0_memory_pop();
	ijvm_l0_memory_push((ijvm_memory_type)(a / b));
	}
     }

void iand()
     {
     int i=ijvm_l0_register_SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_iand\n");
     fprintf(out_l1,"        %d iand %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a && b));
     }

void ior()
     {
     int i=ijvm_l0_register_SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_ior\n");
     fprintf(out_l1,"        %d ior  %d\n",a,b);
     fprintf(out_l1,"                stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"         stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push((ijvm_memory_type)(a || b));
     }

void iload(u_int varnum)
     {
     int i=*LV+varnum+1;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_iload(%d var)\n",varnum);
     fprintf(out_l1,"        %d var=%d\n",varnum,value);
     ijvm_l0_memory_push(value);
     }


void iloadV(int varnum)
     {
     int i=*myLVP+varnum;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_iloadV(%d var)\n",varnum);
     fprintf(out_l1,"        %d var=%d\n",varnum,value);
     ijvm_l0_memory_push(value);
     }

void iloadP(u_int parameternum)
     {
     int i=*myLPP+parameternum;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_iloadP(%d parameter)\n",parameternum);
     fprintf(out_l1,"        %d parameter=%d\n",parameternum,value);
     ijvm_l0_memory_push(value);
     }

void istore(u_int varnum)
     {
     int target=*LV+varnum+1;
     int source=*SP;
     fprintf(out_l1,"  ijvm_l1_istore(%d var)\n",varnum);
     fprintf(out_l1,"        %d var=%d\n",varnum,ijvm_l0_memory[source]);
     ijvm_l0_memory[target]=ijvm_l0_memory[source];
     ijvm_l0_memory_pop();
     }

void ldcw(u_int index)
     {
     int i=ijvm_l0_memory_constantpool.min+index;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_ldcw(%d const)\n",index);
     fprintf(out_l1,"        constantpool[i]=%d\n",index,value);
     ijvm_l0_memory_push(value);
     }

void swap()
     {
     int i=ijvm_l0_register_SP;
     ijvm_memory_type a=ijvm_l0_memory[i-1];
     ijvm_memory_type b=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_swap\n");
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     ijvm_l0_memory_push(b);
     ijvm_l0_memory_push(a);
     }

void iin()
     {
     ijvm_memory_type value=0;
     printf("ijvm_l1_iin\n");
     printf("      < (int) ");
     (void) scanf("%2d", &value);
     // fflush(stdin);   
     /* flush the input stream in case of bad input */
     // value=6;
     fprintf(out_l1,"  ijvm_l1_iin\n");
     fprintf(out_l1,"        < (int) %d\n",value);
     ijvm_l0_memory_push(value);
     }

void iout()
     {
     ijvm_memory_type value=ijvm_l0_memory[*SP];
     printf("ijvm_l1_out\n");
     printf("      > (int) %d\n",value);
     fprintf(out_l1,"  ijvm_l1_out\n");
     fprintf(out_l1,"        > (int) %d\n",value);
     ijvm_l0_memory_pop();
     }

void cin()
     {
     ijvm_memory_type value=0;
     printf("ijvm_l1_cin\n");
     printf("      < (char) ");
     scanf("%c", &value);
     fflush(stdin);   /* flush the input stream in case of bad input */
     fprintf(out_l1,"  ijvm_l1_cin\n");
     fprintf(out_l1,"        < (char) %c\n",value);
     ijvm_l0_memory_push(value);
     }

void cout()
     {
     ijvm_memory_type value=ijvm_l0_memory[*SP];
     printf("ijvm_l1_cout\n");
     printf("      > (char) %c\n",value);
     fprintf(out_l1,"  ijvm_l1_cout\n");
     fprintf(out_l1,"        > (char) %c\n",value);
     ijvm_l0_memory_pop();
     }

void pop()
     {
     fprintf(out_l1,"  ijvm_l1_pop\n");
     ijvm_l0_memory_pop();
     }

void nop()
     {
     fprintf(out_l1,"  ijvm_l1_nop\n");
     }

int  ifeq()
     {
     int i=*SP;
     ijvm_memory_type value=ijvm_l0_memory[i];
     fprintf(out_l1,"  ijvm_l1_ifeq\n");
     fprintf(out_l1,"        check(%d=0)\n",value);
     fprintf(out_l1,"               stackarea[%d]=%d\n",i,value);
     ijvm_l0_memory_pop();
     if (value==0)
	    return 1;
	else
	    return 0;
     }

int  iflt()
     {
     ijvm_memory_type value=ijvm_l0_memory[*SP];
     fprintf(out_l1,"  ijvm_l1_iflt\n");
     fprintf(out_l1,"        check(%d<0)\n",value);
     fprintf(out_l1,"               stackarea[%d]=%d\n",*SP,value);
     ijvm_l0_memory_pop();
     if (value<0)
	    return 1;
	else
	    return 0;
     }

int  ificmpeq()
     {
     int i=ijvm_l0_register_SP;
     ijvm_memory_type a=ijvm_l0_memory[i];
     ijvm_memory_type b=ijvm_l0_memory[i-1];
     fprintf(out_l1,"  ijvm_l1_ificmpeq\n");
     fprintf(out_l1,"        check(%d=%d)\n",a,b);
     fprintf(out_l1,"                 stackarea[%d]=%d\n",i-1,b);
     fprintf(out_l1,"               stackarea[%d]=%d\n",i,a);
     ijvm_l0_memory_pop();
     ijvm_l0_memory_pop();
     if (a==b)
	    return 1;
	else
	    return 0;
     }

void ishow()
     {
     int i=*SP;
     fprintf(out_l1,"  ijvm_l1_ishow\n");
     ijvm_l0_memory_stackarea_show_lastcell();
     fprintf(out_l1,"        stackarea[%d]=%d\n",i,ijvm_l0_memory[i]);
     printf("stackarea[%d]=%d\n",i,ijvm_l0_memory[i]);
     }

int  invokevirtual(u_int constantpooloffset)
     {
     u_int old_PC=ijvm_l0_register_PC;
     u_int old_LV=ijvm_l0_register_LV;

     u_int methodoffset=ijvm_l0_memory[*CPP+constantpooloffset];

     u_int localvars=ijvm_l0_memory[*PC+methodoffset+1];     /* method vars */
     u_int localparameters=ijvm_l0_memory[*PC+methodoffset]; /* method parametri */

     fprintf(out_l1,"  ijvm_l1_invokevirtual(constantpooloffset=%d)\n",constantpooloffset);

     *myLVN=localvars;
     *myLPN=localparameters;

     *myORP =*SP -(localparameters);
     *LV  =*myORP;    /* obj ref pointer */
     *myLPP =*LV +1;  /* local parameter pointer */
     *myLVP =*myLPP +localparameters; /*local var pointer*/
     *SP =*myLVP +localvars;

     ijvm_l0_memory_push(old_PC);
     *myLPC= *SP;
     ijvm_l0_memory_push(old_LV);
     *myLLV= *SP;

     return constantpooloffset;
     }

void ireturn()
     {
     // ijvm_memory_type returnvalue=ijvm_l0_memory[ijvm_l0_register_SP];

     fprintf(out_l1,"  ijvm_l1_ireturn\n");

     *PC=ijvm_l0_memory[*myLPC];
     *LV=ijvm_l0_memory[*myLLV];
     ijvm_l0_memory[*myORP]=ijvm_l0_memory[*SP];  // set return value
     *myLRP=*myORP;
     *SP=*myORP;

     /*
     *myLPN=0;
     *myLVP=0;
     *myLPC=0;
     *myLLV=0;
     */

     }
